#include <gmp.h>

void lowerboundCQ(int n, mpz_t * poly, mpz_t lowerBound, int polyZeroSgn, int negCoeffCount, int* sgnv)
{
    int i, j, jSet, iSet;
    mpz_t tmp1, tmp3, tmp4, tmpLB;
    mm_mpz_get(tmp1);
    mm_mpz_get(tmp3);
    mm_mpz_get(tmp4);
    mm_mpz_get(tmpLB);
    
    jSet = 0;
    mpz_set_ui(tmpLB, INT_MAX);
    if(polyZeroSgn > 0)
    {
        for(j = 0;j < negCoeffCount;j++)
        {
            iSet = 0;
            mpz_set_ui(tmp1, 0);
            for(i = 0;i < sgnv[j];i++)
            {
                if(mpz_sgn(poly[i]) > 0)
                {
                    mpz_set(tmp3, poly[i]);
                    mpz_neg(tmp3, tmp3);
                    mpz_mul_ui(tmp4, poly[sgnv[j]], negCoeffCount);
                    mpz_cdiv_q(tmp3, tmp3, tmp4);
                    mpz_rootrem(tmp3, tmp4, tmp3, sgnv[j] -i);
                    if(mpz_sgn(tmp4) != 0)
                    {
                        mpz_add_ui(tmp3, tmp3, 1);
                    }
                    if(mpz_cmp(tmp3, tmp1) > 0)
                    {
                        mpz_set(tmp1, tmp3);
                        iSet = 1;
                    }
                }
            }
            
            if(iSet && (mpz_cmp(tmpLB, tmp1) > 0))
            {
                mpz_set(tmpLB, tmp1);
                jSet = 1;
            }
        }
    }
    else
    {
        for(j = 0;j < negCoeffCount;j++)
        {
            iSet = 0;
            mpz_set_ui(tmp1, 0);
            for(i = 0;i < sgnv[j];i++)
            {
                if(mpz_sgn(poly[i]) < 0)
                {
                    mpz_set(tmp3, poly[i]);
                    mpz_neg(tmp3, tmp3);
                    mpz_mul_ui(tmp4, poly[sgnv[j]], negCoeffCount);
                    mpz_cdiv_q(tmp3, tmp3, tmp4);
                    mpz_rootrem(tmp3, tmp4, tmp3, sgnv[j] -i);
                    if(mpz_sgn(tmp4) != 0)
                    {
                        mpz_add_ui(tmp3, tmp3, 1);
                    }
                    if(mpz_cmp(tmp3, tmp1) > 0)
                    {
                        mpz_set(tmp1, tmp3);
                        iSet = 1;
                    }
                }
            }
            
            if(iSet && (mpz_cmp(tmpLB, tmp1) > 0))
            {
                mpz_set(tmpLB, tmp1);
                jSet = 1;
            }
        }
    }
    
    if(jSet && mpz_cmp(tmpLB, lowerBound) > 0)
    {
        mpz_set(lowerBound, tmpLB);
#ifdef PRINTLB
        gmp_printf("<CQ:%Zd>", lowerBound);
#endif
    }
    
    mm_mpz_release(tmp1);
    mm_mpz_release(tmp3);
    mm_mpz_release(tmp4);
    mm_mpz_release(tmpLB);
}