#include <gmp.h>
#include "mpz_log2.c"

void lowerboundFL(int n, mpz_t * poly, mpz_t lowerBound, int polyZeroSgn, int negCoeffCount, int* clLength, mpz_t* cl)
{
    int i, j, k, v, iSet = 0, flag = 0, posCounter = 0, negCounter = 0, lastPositiveCoefIndex = 0;
    int temp_log1, temp_log2, min_log = 0;
    mpz_t tmp1;
    mm_mpz_get(tmp1);
    for(i = 0;i <= n;i++)
    {
        clLength[i] = 0;
        mpz_set(cl[i], poly[i]);
    }

    j = 0;
    if(polyZeroSgn > 0)
    {
        while(j < n)
        {
            while(j < n && mpz_sgn(cl[j]) >= 0)
            {
                flag = 0;
                while(j < n && mpz_sgn(cl[j]) > 0)
                {
                    flag = 1;
                    posCounter++;
                    j++;
                }
                if(flag)
                {
                    lastPositiveCoefIndex = j - 1;
                }
                while(j < n && mpz_sgn(cl[j]) == 0)
                {
                    j++;
                }
            }
            if(j == n && mpz_sgn(cl[j]) > 0)
            {
                lastPositiveCoefIndex = j;
                posCounter++;
            }
            while(j < n && mpz_sgn(cl[j]) <= 0)
            {
                while(j < n && mpz_sgn(cl[j]) < 0)
                {
                    negCounter++;
                    j++;
                }
                while(j < n && mpz_sgn(cl[j]) == 0)
                {
                    j++;
                }
            }
            if(j == n && mpz_sgn(cl[j]) < 0)
            {
                negCounter++;
            }
            if(negCounter > posCounter)
            {
                clLength[lastPositiveCoefIndex] = negCounter - posCounter + 1;
            }
            negCounter = 0;
            posCounter = 0;
        }
        i = j = 0;
        while(i <= n && j <= n && negCoeffCount > 0)
        {
            while(mpz_sgn(cl[j]) <= 0)
            {
                j++;
            }
            if(clLength[j] == 0)
            {
                while((clLength[i] > 0 || mpz_sgn(cl[i]) >= 0) && i < n)
                {
                    i++;
                }
                temp_log1 = mpz_log2(cl[j]);
                temp_log2 = mpz_log2rem(cl[i], tmp1);
                if(mpz_sgn(tmp1) > 0)
                {
                    temp_log2++;
                }
                temp_log2 = (temp_log1 - temp_log2) / (i - j);
                if(!iSet)
                {
                    min_log = temp_log2;
                    iSet = 1;
                }
                else if(temp_log2 < min_log)
                {
                    min_log = temp_log2;
                }
                negCoeffCount--;
                i++;
                j++;
            }else{
                k = clLength[j];
                if(k > negCoeffCount)
                {
                    k = negCoeffCount;
                }
                for(v = 0;v < k;v++)
                {
                    while((clLength[i] > 0 ||  mpz_sgn(cl[i]) >= 0) && i < n)
                    {
                        i++;
                    }
                    temp_log1 = mpz_log2(cl[j]);
                    temp_log2 = mpz_log2rem(cl[i], tmp1);
                    if(mpz_sgn(tmp1) > 0)
                    {
                        temp_log2++;
                    }
                    temp_log1 = temp_log1 - temp_log2;
                    temp_log2 = mpz_log2_si(k);
                    temp_log2 = (temp_log1 - temp_log2) / (i - j);
                    if(!iSet)
                    {
                        min_log = temp_log2;
                        iSet = 1;
                    }
                    else if(temp_log2 < min_log)
                    {
                        min_log = temp_log2;
                    }
                    negCoeffCount--;
                    i++;
                }
                j++;
            }
        }
    }
    else
    {
        while(j < n)
        {
            while(j < n && mpz_sgn(cl[j]) <= 0)
            {
                flag = 0;
                while(j < n && mpz_sgn(cl[j]) < 0)
                {
                    flag = 1;
                    posCounter++;
                    j++;
                }
                if(flag)
                {
                    lastPositiveCoefIndex = j - 1;
                }
                while(j < n && mpz_sgn(cl[j]) == 0)
                {
                    j++;
                }
            }
            if(j == n && mpz_sgn(cl[j]) < 0)
            {
                lastPositiveCoefIndex = j;
                posCounter++;
            }
            while(j < n && mpz_sgn(cl[j]) >= 0)
            {
                while(j < n && mpz_sgn(cl[j]) > 0)
                {
                    negCounter++;
                    j++;
                }
                while(j < n && mpz_sgn(cl[j]) == 0)
                {
                    j++;
                }
            }
            if(j == n && mpz_sgn(cl[j]) > 0)
            {
                negCounter++;
            }
            if(negCounter > posCounter)
            {
                clLength[lastPositiveCoefIndex] = negCounter - posCounter + 1;
            }
            negCounter = 0;
            posCounter = 0;
        }
        i = j = 0;
        while(i <= n && j <= n && negCoeffCount > 0)
        {
            while(mpz_sgn(cl[j]) >= 0)
            {
                j++;
            }
            if(clLength[j] == 0)
            {
                while((clLength[i] > 0 || mpz_sgn(cl[i]) <= 0) && i < n)
                {
                    i++;
                }
                temp_log1 = mpz_log2(cl[j]);
                temp_log2 = mpz_log2rem(cl[i], tmp1);
                if(mpz_sgn(tmp1) > 0)
                {
                    temp_log2++;
                }
                temp_log2 = (temp_log1 - temp_log2) / (i - j);
                if(!iSet)
                {
                    min_log = temp_log2;
                    iSet = 1;
                }
                else if(temp_log2 < min_log)
                {
                    min_log = temp_log2;
                }
                negCoeffCount--;
                i++;
                j++;
            }else{
                k = clLength[j];
                if(k > negCoeffCount)
                {
                    k = negCoeffCount;
                }
                for(v = 0;v < k;v++)
                {
                    while((clLength[i] > 0 ||  mpz_sgn(cl[i]) <= 0) && i < n)
                    {
                        i++;
                    }
                    temp_log1 = mpz_log2(cl[j]);
                    temp_log2 = mpz_log2rem(cl[i], tmp1);
                    if(mpz_sgn(tmp1) > 0)
                    {
                        temp_log2++;
                    }
                    temp_log1 = temp_log1 - temp_log2;
                    temp_log2 = mpz_log2_si(k);
                    temp_log2 = (temp_log1 - temp_log2) / (i - j);
                    if(!iSet)
                    {
                        min_log = temp_log2;
                        iSet = 1;
                    }
                    else if(temp_log2 < min_log)
                    {
                        min_log = temp_log2;
                    }
                    negCoeffCount--;
                    i++;
                }
                j++;
            }
        }
    }
    if(iSet && min_log >= 0)
    {
        mpz_set_si(tmp1, 2);
        mpz_pow_ui(tmp1, tmp1, min_log);
        if(mpz_cmp(tmp1, lowerBound) > 0)
        {
            mpz_set(lowerBound, tmp1);
#ifdef PRINTLB
            gmp_printf("<FL:%Zd>", lowerBound);
#endif
        }
    }

    mm_mpz_release(tmp1);
}
