#include <gmp.h>
#include "mpz_log2.c"

void lowerboundLM(int n, mpz_t * poly, mpz_t lowerBound, int polyZeroSgn, int negCoeffCount, int *sgnv)
{
    int i, j, k = 0, t, iSet = 0;
    int temp_log1, temp_log2, min_log = 0;
    mpz_t tmp1;
    mm_mpz_get(tmp1);
    
    j = 0;
    temp_log1 = mpz_log2(poly[j]);
    t = 1;
    if(polyZeroSgn > 0)
    {
        for(i = 0;i < negCoeffCount;i++)
        {
            for(k++;k < sgnv[i];k++)
            {
                if(mpz_cmp(poly[k], poly[j]) > 0)
                {
                    j = k;
                    temp_log2 = mpz_log2(poly[j]);
                    t = 1;
                }
            }
            temp_log2 = mpz_log2rem(poly[k], tmp1);
            if(mpz_sgn(tmp1) > 0)
            {
                temp_log2++;
            }
            temp_log2 = ( -temp_log2 - t + temp_log1) / (k - j);
            if(!iSet)
            {
                min_log = temp_log2;
                iSet = 1;
            }
            else if(temp_log2 < min_log)
            {
                min_log = temp_log2;
            }
            t++;
        }
    }
    else
    {
        for(i = 0;i < negCoeffCount;i++)
        {
            for(k++;k < sgnv[i];k++)
            {
                if(mpz_cmp(poly[k], poly[j]) < 0)
                {
                    j = k;
                    temp_log2 = mpz_log2(poly[j]);
                    t = 1;
                }
            }
            temp_log2 = mpz_log2rem(poly[k], tmp1);
            if(mpz_sgn(tmp1) > 0)
            {
                temp_log2++;
            }
            temp_log2 = ( -temp_log2 - t + temp_log1) / (k - j);
            if(!iSet)
            {
                min_log = temp_log2;
                iSet = 1;
            }
            else if(temp_log2 < min_log)
            {
                min_log = temp_log2;
            }
            t++;
        }
    }
    
    if(iSet && min_log >= 0)
    {
        mpz_set_si(tmp1, 2);
        mpz_pow_ui(tmp1, tmp1, min_log);
        if(mpz_cmp(tmp1, lowerBound) > 0)
        {
            mpz_set(lowerBound, tmp1);
            #ifdef PRINTLB
            gmp_printf("<LM:%Zd>", lowerBound);
            #endif
        }
    }

    mm_mpz_release(tmp1);
}
