#include <gmp.h>
#include "mpz_log2.c"

void lowerboundLMQ(int n, mpz_t * poly, mpz_t lowerBound, int polyZeroSgn, int negCoeffCount,int *sgnv)
{
    int i, j, jSet, iSet, t;
    int temp_log1, temp_log2, min_log = 0, max_log;
    mpz_t tmp1;
    mm_mpz_get(tmp1);
    
    jSet = 0;
    if(polyZeroSgn > 0)
    {
        for(j = 0;j < negCoeffCount;j++)
        {
            iSet = 0;
            max_log = 0;
            temp_log1 = mpz_log2rem(poly[sgnv[j]], tmp1);
            if(mpz_sgn(tmp1) > 0)
            {
                temp_log1++;
            }
            t = 1;
            for(i = 0;i < sgnv[j];i++)
            {
                if(mpz_sgn(poly[i]) > 0)
                {
                    temp_log2 = mpz_log2(poly[i]);
                    temp_log2 = ( -temp_log1 - t + temp_log2) / (sgnv[j] -i);
                    t++;
                    if(!iSet)
                    {
                        max_log = temp_log2;
                        iSet = 1;
                    }
                    else if(max_log < temp_log2)
                    {
                        max_log = temp_log2;
                    }
                }
            }
            
            if(iSet)
            {
                if(!jSet)
                {
                    min_log = max_log;
                    jSet = 1;
                }
                else if(min_log > max_log)
                {
                    min_log = max_log;
                }
            }
        }
    }
    else
    {
        for(j = 0;j < negCoeffCount;j++)
        {
            iSet = 0;
            max_log = 0;
            temp_log1 = mpz_log2rem(poly[sgnv[j]], tmp1);
            if(mpz_sgn(tmp1) > 0)
            {
                temp_log1++;
            }
            t = 1;
            for(i = 0;i < sgnv[j];i++)
            {
                if(mpz_sgn(poly[i]) < 0)
                {
                    temp_log2 = mpz_log2(poly[i]);
                    temp_log2 = ( -temp_log1 - t + temp_log2) / (sgnv[j] -i);
                    t++;
                    if(!iSet)
                    {
                        max_log = temp_log2;
                        iSet = 1;
                    }
                    else if(max_log < temp_log2)
                    {
                        max_log = temp_log2;
                    }
                }
            }
            
            if(iSet)
            {
                if(!jSet)
                {
                    min_log = max_log;
                    jSet = 1;
                }
                else if(min_log > max_log)
                {
                    min_log = max_log;
                }
            }
        }
    }
    if(jSet && min_log >= 0)
    {
        mpz_set_si(tmp1, 2);
        mpz_pow_ui(tmp1, tmp1, min_log);
        if(mpz_cmp(tmp1, lowerBound) > 0)
        {
            mpz_set(lowerBound, tmp1);
            #ifdef PRINTLB
            gmp_printf("<LMQ:%Zd>", lowerBound);
            #endif
        }
    }
    
    mm_mpz_release(tmp1);
}