#include <gmp.h>

void lowerboundLM(int n, mpz_t * poly, mpz_t lowerBound, int polyZeroSgn, int negCoeffCount, int *sgnv)
{
    int i, j, k = 0, t, iSet = 0;
    mpz_t tmp1, tmp2, tmp3, tmpLB;
    mm_mpz_get(tmp1);
    mm_mpz_get(tmp2);
    mm_mpz_get(tmp3);
    mm_mpz_get(tmpLB);
    
    mpz_set_ui(tmpLB, INT_MAX);
    j = 0;
    t = 1;
    mpz_set_ui(tmp2, 2);
    if(polyZeroSgn > 0)
    {
        for(i = 0;i < negCoeffCount;i++)
        {
            for(k++;k < sgnv[i];k++)
            {
                if(mpz_cmp(poly[k], poly[j]) > 0)
                {
                    j = k;
                    t = 1;
                }
            }
            mpz_pow_ui(tmp1, tmp2, t);
            mpz_mul(tmp1, tmp1, poly[k]);
            mpz_fdiv_q(tmp1, poly[j], tmp1);
            mpz_neg(tmp1, tmp1);
            mpz_root(tmp1, tmp1, k - j);
            if(mpz_cmp(tmp1, lowerBound) < 0)
            {
                goto CLEAR;
            }
            if(mpz_cmp(tmp1, tmpLB) < 0)
            {
                mpz_set(tmpLB, tmp1);
                iSet = 1;
            }
            t++;
        }
    }
    else
    {
        for(i = 0;i < negCoeffCount;i++)
        {
            for(k++;k < sgnv[i];k++)
            {
                if(mpz_cmp(poly[k], poly[j]) < 0)
                {
                    j = k;
                    t = 1;
                }
            }
            mpz_pow_ui(tmp1, tmp2, t);
            mpz_mul(tmp1, tmp1, poly[k]);
            mpz_fdiv_q(tmp1, poly[j], tmp1);
            mpz_neg(tmp1, tmp1);
            mpz_root(tmp1, tmp1, k - j);
            if(mpz_cmp(tmp1, lowerBound) < 0)
            {
                goto CLEAR;
            }
            if(mpz_cmp(tmp1, tmpLB) < 0)
            {
                mpz_set(tmpLB, tmp1);
                iSet = 1;
            }
            t++;
        }
    }
    
    if(iSet && mpz_cmp(tmpLB, lowerBound) > 0)
    {
        mpz_set(lowerBound, tmpLB);
#ifdef PRINTLB
        gmp_printf("<LM:%Zd>", lowerBound);
#endif
    }
    
    CLEAR:
    mm_mpz_release(tmp1);
    mm_mpz_release(tmp2);
    mm_mpz_release(tmp3);
    mm_mpz_release(tmpLB);
}
