#include <gmp.h>

void lowerboundOFL4(int n, mpz_t * poly, mpz_t lowerBound, int polyZeroSgn, int negCoeffCount, int* clLength, mpz_t* cl)
{
    int i, j, k, v, iSet = 0, flag = 0, posCounter = 0, negCounter = 0, firstPositiveCoefIndex = 0, firstNegativeCoefIndex = 0;
    mpz_t tmpLB, tmp1, tmp2;
    mm_mpz_get(tmp1);
    mm_mpz_get(tmp2);
    mm_mpz_get(tmpLB);
    
    for(i = 0;i <= n;i++)
    {
        clLength[i] = 0;
        mpz_set(cl[i], poly[i]);
    }
    
    mpz_set_ui(tmpLB, INT_MAX);
    j = 0;
    if(polyZeroSgn > 0)
    {
        while(j < n)
        {
            firstPositiveCoefIndex = -1;
            while(j < n && mpz_sgn(cl[j]) >= 0)
            {
                flag = 0;
                while(j < n && mpz_sgn(cl[j]) > 0)
                {
                    if(!flag)
                    {
                        firstPositiveCoefIndex = j;
                        flag = 1;
                    }
                    posCounter++;
                    j++;
                }
                while(j < n && mpz_sgn(cl[j]) == 0)
                {
                    j++;
                }
            }
            if(j == n && mpz_sgn(cl[j]) > 0)
            {
                if(firstPositiveCoefIndex < 0)
                {
                    firstPositiveCoefIndex = j;
                }
                posCounter++;
            }
            firstNegativeCoefIndex = -1;
            while(j < n && mpz_sgn(cl[j]) <= 0)
            {
                flag = 0;
                while(j < n && mpz_sgn(cl[j]) < 0)
                {
                    if(!flag)
                    {
                        firstNegativeCoefIndex = j;
                        flag = 1;
                    }
                    negCounter++;
                    j++;
                }
                while(j < n && mpz_sgn(cl[j]) == 0)
                {
                    j++;
                }
            }
            if(j == n && mpz_sgn(cl[j]) < 0)
            {
                if(firstNegativeCoefIndex < 0)
                {
                    firstNegativeCoefIndex = j;
                }
                negCounter++;
            }
            if(negCounter > posCounter)
            {
                clLength[firstPositiveCoefIndex] = negCounter - posCounter + 1;
                mpz_fdiv_q_ui(cl[firstPositiveCoefIndex], cl[firstPositiveCoefIndex], clLength[firstPositiveCoefIndex]);
            }
            else if(posCounter > negCounter && negCounter > 0)
            {
                clLength[firstNegativeCoefIndex] = posCounter - negCounter + 1;
                mpz_cdiv_q_ui(cl[firstNegativeCoefIndex], cl[firstNegativeCoefIndex], clLength[firstNegativeCoefIndex]);
            }
            negCounter = 0;
            posCounter = 0;
        }
        i = j = 0;
        while(i <= n && j <= n && negCoeffCount > 0)
        {
            while(mpz_sgn(cl[j]) <= 0)
            {
                j++;
            }
            if(clLength[j] == 0)
            {
                while(mpz_sgn(cl[i]) >= 0 && i < n)
                {
                    i++;
                }
                if(clLength[i] == 0)
                {
                    mpz_fdiv_q(tmp1, cl[j], cl[i]);
                    mpz_neg(tmp1, tmp1);
                    mpz_root(tmp1, tmp1, i - j);
                    if(mpz_cmp(tmp1, lowerBound) < 0)
                    {
                        goto CLEAR;
                    }
                    if(mpz_cmp(tmp1, tmpLB) < 0)
                    {
                        mpz_set(tmpLB, tmp1);
                        iSet = 1;
                    }
                    i++;
                    j++;
                }else{
                    k = clLength[i];
                    for(v = 0;v < k;v++)
                    {
                        mpz_fdiv_q(tmp1, cl[j], cl[i]);
                        mpz_neg(tmp1, tmp1);
                        mpz_root(tmp1, tmp1, i - j);
                        if(mpz_cmp(tmp1, lowerBound) < 0)
                        {
                            goto CLEAR;
                        }
                        if(mpz_cmp(tmp1, tmpLB) < 0)
                        {
                            mpz_set(tmpLB, tmp1);
                            iSet = 1;
                        }
                        j++;
                        while(mpz_sgn(cl[j]) <= 0)
                        {
                            j++;
                        }
                    }
                    i++;
                }
                negCoeffCount--;
            }else{
                k = clLength[j];
                for(v = 0;v < k;v++)
                {
                    while(mpz_sgn(cl[i]) >= 0 && i < n)
                    {
                        i++;
                    }
                    mpz_fdiv_q(tmp1, cl[j], cl[i]);
                    mpz_neg(tmp1, tmp1);
                    mpz_root(tmp1, tmp1, i - j);
                    if(mpz_cmp(tmp1, lowerBound) < 0)
                    {
                        goto CLEAR;
                    }
                    if(mpz_cmp(tmp1, tmpLB) < 0)
                    {
                        mpz_set(tmpLB, tmp1);
                        iSet = 1;
                    }
                    negCoeffCount--;
                    i++;
                }
                j++;
            }
        }
    }
    else
    {
        while(j < n)
        {
            firstPositiveCoefIndex = -1;
            while(j < n && mpz_sgn(cl[j]) <= 0)
            {
                flag = 0;
                while(j < n && mpz_sgn(cl[j]) < 0)
                {
                    if(!flag)
                    {
                        firstPositiveCoefIndex = j;
                    }
                    posCounter++;
                    j++;
                }
                while(j < n && mpz_sgn(cl[j]) == 0)
                {
                    j++;
                }
            }
            if(j == n && mpz_sgn(cl[j]) < 0)
            {
                if(firstPositiveCoefIndex < 0)
                {
                    firstPositiveCoefIndex = j;
                }
                posCounter++;
            }
            firstNegativeCoefIndex = -1;
            while(j < n && mpz_sgn(cl[j]) >= 0)
            {
                flag = 0;
                while(j < n && mpz_sgn(cl[j]) > 0)
                {
                    if(!flag)
                    {
                        firstNegativeCoefIndex = j;
                        flag = 1;
                    }
                    negCounter++;
                    j++;
                }
                while(j < n && mpz_sgn(cl[j]) == 0)
                {
                    j++;
                }
            }
            if(j == n && mpz_sgn(cl[j]) > 0)
            {
                if(firstNegativeCoefIndex < 0)
                {
                    firstNegativeCoefIndex = j;
                }
                negCounter++;
            }
            if(negCounter > posCounter)
            {
                clLength[firstPositiveCoefIndex] = negCounter - posCounter + 1;
                mpz_fdiv_q_ui(cl[firstPositiveCoefIndex], cl[firstPositiveCoefIndex], clLength[firstPositiveCoefIndex]);
            }
            else if(posCounter > negCounter && negCounter > 0)
            {
                clLength[firstNegativeCoefIndex] = posCounter - negCounter + 1;
                mpz_cdiv_q_ui(cl[firstNegativeCoefIndex], cl[firstNegativeCoefIndex], clLength[firstNegativeCoefIndex]);
            }
            negCounter = 0;
            posCounter = 0;
        }
        i = j = 0;
        while(i <= n && j <= n && negCoeffCount > 0)
        {
            while(mpz_sgn(cl[j]) >= 0)
            {
                j++;
            }
            if(clLength[j] == 0)
            {
                while(mpz_sgn(cl[i]) <= 0 && i < n)
                {
                    i++;
                }
                if(clLength[i] == 0)
                {
                    mpz_fdiv_q(tmp1, cl[j], cl[i]);
                    mpz_neg(tmp1, tmp1);
                    mpz_root(tmp1, tmp1, i - j);
                    if(mpz_cmp(tmp1, lowerBound) < 0)
                    {
                        goto CLEAR;
                    }
                    if(mpz_cmp(tmp1, tmpLB) < 0)
                    {
                        mpz_set(tmpLB, tmp1);
                        iSet = 1;
                    }
                    i++;
                    j++;
                }else{
                    k = clLength[i];
                    for(v = 0;v < k;v++)
                    {
                        mpz_fdiv_q(tmp1, cl[j], cl[i]);
                        mpz_neg(tmp1, tmp1);
                        mpz_root(tmp1, tmp1, i - j);
                        if(mpz_cmp(tmp1, lowerBound) < 0)
                        {
                            goto CLEAR;
                        }
                        if(mpz_cmp(tmp1, tmpLB) < 0)
                        {
                            mpz_set(tmpLB, tmp1);
                            iSet = 1;
                        }
                        j++;
                        while(mpz_sgn(cl[j]) >= 0)
                        {
                            j++;
                        }
                    }
                    i++;
                }
                negCoeffCount--;
            }else{
                k = clLength[j];
                for(v = 0;v < k;v++)
                {
                    while(mpz_sgn(cl[i]) <= 0 && i < n)
                    {
                        i++;
                    }
                    mpz_fdiv_q(tmp1, cl[j], cl[i]);
                    mpz_neg(tmp1, tmp1);
                    mpz_root(tmp1, tmp1, i - j);
                    if(mpz_cmp(tmp1, lowerBound) < 0)
                    {
                        goto CLEAR;
                    }
                    if(mpz_cmp(tmp1, tmpLB) < 0)
                    {
                        mpz_set(tmpLB, tmp1);
                        iSet = 1;
                    }
                    negCoeffCount--;
                    i++;
                }
                j++;
            }
        }
    }
    
    if(iSet && mpz_cmp(tmpLB, lowerBound) > 0)
    {
        mpz_set(lowerBound, tmpLB);
#ifdef PRINTLB
        gmp_printf("<OFL4:%Zd>", lowerBound);
#endif
    }
    
    CLEAR:
    mm_mpz_release(tmp1);
    mm_mpz_release(tmp2);
    mm_mpz_release(tmpLB);
}
