#include <stdio.h>
#include <gmp.h>
#include "mpz_log2.c"


void lowerboundOFL5(int n, mpz_t * poly, mpz_t lowerBound, int polyZeroSgn, int negCoeffCount)
{
    mpz_t temp1;
    int posStartIndex = 0, posEndIndex, negTailIndex = n;
    int negHeadStartIndex, negHeadEndIndex, posCount, negHeadCount;
    int i, j, k, v;
    int iSet = 0;
    int temp_log1, temp_log2, min_log = 0;
    mm_mpz_get(temp1);
    
    if(polyZeroSgn > 0)
    {
        while(negTailIndex >= 0 && mpz_sgn(poly[negTailIndex]) >= 0)
        {
            negTailIndex--;
        }
        while(negCoeffCount > 0)
        {
            while(posStartIndex <= n && mpz_sgn(poly[posStartIndex]) <= 0)
            {
                posStartIndex++;
            }
            posEndIndex = posStartIndex + 1;
            while(posEndIndex <= n && mpz_sgn(poly[posEndIndex]) >= 0)
            {
                posEndIndex++;
            }
            negHeadStartIndex = negHeadEndIndex = posEndIndex;
            while(negHeadEndIndex <= n && negHeadEndIndex <= negTailIndex && mpz_sgn(poly[negHeadEndIndex]) <= 0)
            {
                negHeadEndIndex++;
            }
            posCount = posEndIndex - posStartIndex;
            negHeadCount = negHeadEndIndex - negHeadStartIndex;
            
            // greater index negative coefficients is first paired
            j = posStartIndex;
            if(negHeadCount > 0)
            {
                i = negHeadStartIndex;
                while(negHeadCount > 0)
                {
                    // when lack of positive coefficients
                    // split last positive index
                    if(posCount == 1 && negHeadCount > posCount)
                    {
                        k = negHeadCount - posCount + 1;
                        for(v = 0;v < k;v++)
                        {
                            temp_log1 = mpz_log2(poly[j]);
                            temp_log2 = mpz_log2rem(poly[i], temp1);
                            if(mpz_sgn(temp1) > 0)
                            {
                                temp_log2++;
                            }
                            temp_log1 = temp_log1 - temp_log2;
                            temp_log2 = mpz_log2_si(k);
                            temp_log2 = (temp_log1 - temp_log2) / (i - j);
                            if(!iSet)
                            {
                                min_log = temp_log2;
                                iSet = 1;
                            }
                            else if(temp_log2 < min_log)
                            {
                                min_log = temp_log2;
                            }
                            negHeadCount--;
                            negCoeffCount--;
                            i++;
                            while(i <= n && mpz_sgn(poly[i]) == 0)
                            {
                                i++;
                            }
                        }
                    }
                    else
                    {
                        temp_log1 = mpz_log2(poly[j]);
                        temp_log2 = mpz_log2rem(poly[i], temp1);
                        if(mpz_sgn(temp1) > 0)
                        {
                            temp_log2++;
                        }
                        temp_log2 = (temp_log1 - temp_log2) / (i - j);
                        if(!iSet)
                        {
                            min_log = temp_log2;
                            iSet = 1;
                        }
                        else if(temp_log2 < min_log)
                        {
                            min_log = temp_log2;
                        }
                        negHeadCount--;
                        negCoeffCount--;
                        i++;
                        while(i <= n && mpz_sgn(poly[i]) == 0)
                        {
                            i++;
                        }
                    }
                    posCount--;
                    
                    if(posCount > 0)
                    {
                        j++;
                        while(mpz_sgn(poly[j]) == 0)
                        {
                            j++;
                        }
                    }
                }
            }
            
            // when there are rest of positive coefficients
            // pair tail negative coefficient
            while(posCount > 0 && negHeadEndIndex < negTailIndex)
            {
                i = negTailIndex;
                temp_log1 = mpz_log2(poly[j]);
                temp_log2 = mpz_log2rem(poly[i], temp1);
                if(mpz_sgn(temp1) > 0)
                {
                    temp_log2++;
                }
                temp_log2 = (temp_log1 - temp_log2) / (i - j);
                if(!iSet)
                {
                    min_log = temp_log2;
                    iSet = 1;
                }
                else if(temp_log2 < min_log)
                {
                    min_log = temp_log2;
                }
                posCount--;
                negCoeffCount--;
                if(negCoeffCount == 0)
                {
                    break;
                }
                negTailIndex--;
                while(negTailIndex >= 0 && mpz_sgn(poly[negTailIndex]) >= 0)
                {
                    negTailIndex--;
                }
                if(posCount > 0)
                {
                    j++;
                    while(mpz_sgn(poly[j]) == 0)
                    {
                        j++;
                    }
                }
            }
            
            posStartIndex = negHeadEndIndex;
        }
    }
    else
    {
        while(negTailIndex >= 0 && mpz_sgn(poly[negTailIndex]) <= 0)
        {
            negTailIndex--;
        }
        while(negCoeffCount > 0)
        {
            while(posStartIndex <= n && mpz_sgn(poly[posStartIndex]) >= 0)
            {
                posStartIndex++;
            }
            posEndIndex = posStartIndex + 1;
            while(posEndIndex <= n && mpz_sgn(poly[posEndIndex]) <= 0)
            {
                posEndIndex++;
            }
            negHeadStartIndex = negHeadEndIndex = posEndIndex;
            while(negHeadEndIndex <= n && negHeadEndIndex <= negTailIndex && mpz_sgn(poly[negHeadEndIndex]) >= 0)
            {
                negHeadEndIndex++;
            }
            posCount = posEndIndex - posStartIndex;
            negHeadCount = negHeadEndIndex - negHeadStartIndex;
            
            // greater index negative coefficients is first paired
            j = posStartIndex;
            if(negHeadCount > 0)
            {
                i = negHeadStartIndex;
                while(negHeadCount > 0)
                {
                    // when lack of positive coefficients
                    // split last positive index
                    if(posCount == 1 && negHeadCount > posCount)
                    {
                        k = negHeadCount - posCount + 1;
                        for(v = 0;v < k;v++)
                        {
                            temp_log1 = mpz_log2(poly[j]);
                            temp_log2 = mpz_log2rem(poly[i], temp1);
                            if(mpz_sgn(temp1) > 0)
                            {
                                temp_log2++;
                            }
                            temp_log1 = temp_log1 - temp_log2;
                            temp_log2 = mpz_log2_si(k);
                            temp_log2 = (temp_log1 - temp_log2) / (i - j);
                            if(!iSet)
                            {
                                min_log = temp_log2;
                                iSet = 1;
                            }
                            else if(temp_log2 < min_log)
                            {
                                min_log = temp_log2;
                            }
                            negHeadCount--;
                            negCoeffCount--;
                            i++;
                            while(i <= n && mpz_sgn(poly[i]) == 0)
                            {
                                i++;
                            }
                        }
                    }
                    else
                    {
                        temp_log1 = mpz_log2(poly[j]);
                        temp_log2 = mpz_log2rem(poly[i], temp1);
                        if(mpz_sgn(temp1) > 0)
                        {
                            temp_log2++;
                        }
                        temp_log2 = (temp_log1 - temp_log2) / (i - j);
                        if(!iSet)
                        {
                            min_log = temp_log2;
                            iSet = 1;
                        }
                        else if(temp_log2 < min_log)
                        {
                            min_log = temp_log2;
                        }
                        negHeadCount--;
                        negCoeffCount--;
                        i++;
                        while(i <= n && mpz_sgn(poly[i]) == 0)
                        {
                            i++;
                        }
                    }
                    posCount--;
                    
                    if(posCount > 0)
                    {
                        j++;
                        while(mpz_sgn(poly[j]) == 0)
                        {
                            j++;
                        }
                    }
                }
            }
            
            // when there are rest of positive coefficients
            // pair tail negative coefficient
            while(posCount > 0 && negHeadEndIndex < negTailIndex)
            {
                i = negTailIndex;
                temp_log1 = mpz_log2(poly[j]);
                temp_log2 = mpz_log2rem(poly[i], temp1);
                if(mpz_sgn(temp1) > 0)
                {
                    temp_log2++;
                }
                temp_log2 = (temp_log1 - temp_log2) / (i - j);
                if(!iSet)
                {
                    min_log = temp_log2;
                    iSet = 1;
                }
                else if(temp_log2 < min_log)
                {
                    min_log = temp_log2;
                }
                posCount--;
                negCoeffCount--;
                if(negCoeffCount == 0)
                {
                    break;
                }
                negTailIndex--;
                while(negTailIndex >= 0 && mpz_sgn(poly[negTailIndex]) <= 0)
                {
                    negTailIndex--;
                }
                if(posCount > 0)
                {
                    j++;
                    while(mpz_sgn(poly[j]) == 0)
                    {
                        j++;
                    }
                }
            }
            
            posStartIndex = negHeadEndIndex;
        }
    }
    
    if(iSet && min_log >= 0)
    {
        mpz_set_si(temp1, 2);
        mpz_pow_ui(temp1, temp1, min_log);
        if(mpz_cmp(temp1, lowerBound) > 0)
        {
            mpz_set(lowerBound, temp1);
#ifdef PRINTLB
            gmp_printf("<OFL5:%Zd>", lowerBound);
#endif
        }
    }
    mm_mpz_release(temp1);
}
