#include <stdio.h>
#include <gmp.h>


void lowerboundOFL5(int n, mpz_t * poly, mpz_t lowerBound, int polyZeroSgn, int negCoeffCount)
{
    mpz_t temp1, temp2, tempLB;
    int posStartIndex = 0, posEndIndex, negTailIndex = n;
    int negHeadStartIndex, negHeadEndIndex, posCount, negHeadCount;
    int i, j, k, v;
    int iSet = 0;
    mm_mpz_get(temp1);
    mm_mpz_get(temp2);
    mm_mpz_get(tempLB);
    
    if(polyZeroSgn > 0)
    {
        while(negTailIndex >= 0 && mpz_sgn(poly[negTailIndex]) >= 0)
        {
            negTailIndex--;
        }
        while(negCoeffCount > 0)
        {
            while(posStartIndex <= n && mpz_sgn(poly[posStartIndex]) <= 0)
            {
                posStartIndex++;
            }
            posEndIndex = posStartIndex + 1;
            while(posEndIndex <= n && mpz_sgn(poly[posEndIndex]) >= 0)
            {
                posEndIndex++;
            }
            negHeadStartIndex = negHeadEndIndex = posEndIndex;
            while(negHeadEndIndex <= n && negHeadEndIndex <= negTailIndex && mpz_sgn(poly[negHeadEndIndex]) <= 0)
            {
                negHeadEndIndex++;
            }
            posCount = posEndIndex - posStartIndex;
            negHeadCount = negHeadEndIndex - negHeadStartIndex;
            
            // greater index negative coefficients is first paired
            j = posStartIndex;
            if(negHeadCount > 0)
            {
                i = negHeadStartIndex;
                while(negHeadCount > 0)
                {
                    // when lack of positive coefficients
                    // split last positive index
                    if(posCount == 1 && negHeadCount > posCount)
                    {
                        k = negHeadCount - posCount + 1;
                        for(v = 0;v < k;v++)
                        {
                            mpz_fdiv_q_ui(temp1, poly[j], k);
                            mpz_fdiv_q(temp1, temp1, poly[i]);
                            mpz_neg(temp1, temp1);
                            mpz_root(temp1, temp1, i - j);
                            if(mpz_cmp(temp1, lowerBound) < 0)
                            {
                                goto CLEAR;
                            }
                            if(!iSet)
                            {
                                mpz_set(tempLB, temp1);
                                iSet = 1;
                            }
                            else if(mpz_cmp(temp1, tempLB) < 0)
                            {
                                mpz_set(tempLB, temp1);
                            }
                            negHeadCount--;
                            negCoeffCount--;
                        }
                        posCount--;
                    }
                    else
                    {
                        mpz_fdiv_q(temp1, poly[j], poly[i]);
                        mpz_neg(temp1, temp1);
                        mpz_root(temp1, temp1, i - j);
                        if(mpz_cmp(temp1, lowerBound) < 0)
                        {
                            goto CLEAR;
                        }
                        if(!iSet)
                        {
                            mpz_set(tempLB, temp1);
                            iSet = 1;
                        }
                        else if(mpz_cmp(temp1, tempLB) < 0)
                        {
                            mpz_set(tempLB, temp1);
                        }
                        posCount--;
                        negHeadCount--;
                        negCoeffCount--;
                    }
                    
                    if(posCount > 0)
                    {
                        j++;
                        while(mpz_sgn(poly[j]) == 0)
                        {
                            j++;
                        }
                    }
                    
                    if(negHeadCount == 0)
                    {
                        break;
                    }
                    i++;
                    while(mpz_sgn(poly[i]) == 0)
                    {
                        i++;
                    }
                }
            }
            
            // when there are rest of positive coefficients
            // pair tail negative coefficient
            while(posCount > 0 && negHeadEndIndex < negTailIndex)
            {
                i = negTailIndex;
                mpz_fdiv_q(temp1, poly[j], poly[i]);
                mpz_neg(temp1, temp1);
                mpz_root(temp1, temp1, i - j);
                if(mpz_cmp(temp1, lowerBound) < 0)
                {
                    goto CLEAR;
                }
                if(!iSet)
                {
                    mpz_set(tempLB, temp1);
                    iSet = 1;
                }
                else if(mpz_cmp(temp1, tempLB) < 0)
                {
                    mpz_set(tempLB, temp1);
                }
                posCount--;
                negCoeffCount--;
                if(negCoeffCount == 0)
                {
                    break;
                }
                negTailIndex--;
                while(negTailIndex >= 0 && mpz_sgn(poly[negTailIndex]) >= 0)
                {
                    negTailIndex--;
                }
                if(posCount > 0)
                {
                    j++;
                    while(mpz_sgn(poly[j]) == 0)
                    {
                        j++;
                    }
                }
            }
            
            posStartIndex = negHeadEndIndex;
        }
    }
    else
    {
        while(negTailIndex >= 0 && mpz_sgn(poly[negTailIndex]) <= 0)
        {
            negTailIndex--;
        }
        while(negCoeffCount > 0)
        {
            while(posStartIndex <= n && mpz_sgn(poly[posStartIndex]) >= 0)
            {
                posStartIndex++;
            }
            posEndIndex = posStartIndex + 1;
            while(posEndIndex <= n && mpz_sgn(poly[posEndIndex]) <= 0)
            {
                posEndIndex++;
            }
            negHeadStartIndex = negHeadEndIndex = posEndIndex;
            while(negHeadEndIndex <= n && negHeadEndIndex <= negTailIndex && mpz_sgn(poly[negHeadEndIndex]) >= 0)
            {
                negHeadEndIndex++;
            }
            posCount = posEndIndex - posStartIndex;
            negHeadCount = negHeadEndIndex - negHeadStartIndex;
            
            // greater index negative coefficients is first paired
            j = posStartIndex;
            if(negHeadCount > 0)
            {
                i = negHeadStartIndex;
                while(negHeadCount > 0)
                {
                    // when lack of positive coefficients
                    // split last positive index
                    if(posCount == 1 && negHeadCount > posCount)
                    {
                        k = negHeadCount - posCount + 1;
                        for(v = 0;v < k;v++)
                        {
                            mpz_fdiv_q_ui(temp1, poly[j], k);
                            mpz_fdiv_q(temp1, temp1, poly[i]);
                            mpz_neg(temp1, temp1);
                            mpz_root(temp1, temp1, i - j);
                            if(mpz_cmp(temp1, lowerBound) < 0)
                            {
                                goto CLEAR;
                            }
                            if(!iSet)
                            {
                                mpz_set(tempLB, temp1);
                                iSet = 1;
                            }
                            else if(mpz_cmp(temp1, tempLB) < 0)
                            {
                                mpz_set(tempLB, temp1);
                            }
                            negHeadCount--;
                            negCoeffCount--;
                        }
                        posCount--;
                    }
                    else
                    {
                        mpz_fdiv_q(temp1, poly[j], poly[i]);
                        mpz_neg(temp1, temp1);
                        mpz_root(temp1, temp1, i - j);
                        if(mpz_cmp(temp1, lowerBound) < 0)
                        {
                            goto CLEAR;
                        }
                        if(!iSet)
                        {
                            mpz_set(tempLB, temp1);
                            iSet = 1;
                        }
                        else if(mpz_cmp(temp1, tempLB) < 0)
                        {
                            mpz_set(tempLB, temp1);
                        }
                        posCount--;
                        negHeadCount--;
                        negCoeffCount--;
                    }
                    
                    if(posCount > 0)
                    {
                        j++;
                        while(mpz_sgn(poly[j]) == 0)
                        {
                            j++;
                        }
                    }
                    
                    if(negHeadCount == 0)
                    {
                        break;
                    }
                    i++;
                    while(mpz_sgn(poly[i]) == 0)
                    {
                        i++;
                    }
                }
            }
            
            // when there are rest of positive coefficients
            // pair tail negative coefficient
            while(posCount > 0 && negHeadEndIndex < negTailIndex)
            {
                i = negTailIndex;
                mpz_fdiv_q(temp1, poly[j], poly[i]);
                mpz_neg(temp1, temp1);
                if(negCoeffCount < 0)
                {
                    abort();
                }
                mpz_root(temp1, temp1, i - j);
                if(mpz_cmp(temp1, lowerBound) < 0)
                {
                    goto CLEAR;
                }
                if(!iSet)
                {
                    mpz_set(tempLB, temp1);
                    iSet = 1;
                }
                else if(mpz_cmp(temp1, tempLB) < 0)
                {
                    mpz_set(tempLB, temp1);
                }
                posCount--;
                negCoeffCount--;
                if(negCoeffCount == 0)
                {
                    break;
                }
                negTailIndex--;
                while(negTailIndex >= 0 && mpz_sgn(poly[negTailIndex]) <= 0)
                {
                    negTailIndex--;
                }
                if(posCount > 0)
                {
                    j++;
                    while(mpz_sgn(poly[j]) == 0)
                    {
                        j++;
                    }
                }
            }
            
            posStartIndex = negHeadEndIndex;
        }
    }
    
    if(iSet && mpz_cmp(tempLB, lowerBound) > 0)
    {
        mpz_set(lowerBound, tempLB);
#ifdef PRINTLB
        gmp_printf("<OFL5:%Zd>", lowerBound);
#endif
    }
    CLEAR:
    mm_mpz_release(temp1);
    mm_mpz_release(temp2);
    mm_mpz_release(tempLB);
}
