#include <stdio.h>
#include <stdlib.h>
#include <gmp.h>

mpz_t * generate(int n)
{
    mpz_t * ret;
    int i;
    ret = (mpz_t * )malloc(sizeof(mpz_t) * (n + 1));
    for(i = 0;i <= n;i++)
    {
        mpz_init(ret[i]);
    }
    mpz_set_si(ret[0], -2);
    mpz_set_si(ret[1], 20);
    mpz_set_si(ret[2], -50);
    mpz_add_ui(ret[n], ret[n], 1);
    return ret;
}

int main(int argc, char * argv[])
{
    int i, n;
    mpz_t * poly;
    FILE * file;
    
    if(argc != 3)
    {
        printf("Usage mignotte_poly_gen.exe <dim> <out>\n");
        return 0;
    }
    n = atoi(argv[1]);
    if(n < 2)
    {
        printf("dim must be greater than or equal to 2\n");
        return 0;
    }
    file = fopen(argv[2], "w");
    poly = generate(n);
    for(i = n;i >= 0;i--)
    {
        fprintf(file, "(");
        mpz_out_str(file, 10, poly[i]);
        if(i == 0)
        {
            fprintf(file, ")");
        }else{
            fprintf(file, ")*x^%d+", i);
        }
    }
    
    fclose(file);
    
    return 0;
}
