#include <gmp.h>

void upperbound(int n,mpz_t *poly, mpz_t upperBound, int* sgnv)
{
    
    int j, sgn, sgn0, k;
    mpz_t tmp1, tmp2, tmp3, tmp4, tmp5;
    mm_mpz_get(tmp1);
    mm_mpz_get(tmp2);
    mm_mpz_get(tmp3);
    mm_mpz_get(tmp4);
    mm_mpz_get(tmp5);
    
    sgn=mpz_sgn(poly[n]);
    
    // record negative coefficient
    k=0;
    for(j=0;j<n;j++)
    {
        if( (sgn0=mpz_sgn(poly[j]))!=0 && sgn0!=sgn )
        {
            sgnv[k]=j;
            k=k+1;
        }
    }
    
    mpz_neg(tmp2,poly[n]);
    mpz_set_si(tmp1,0);
    mpz_set_si(tmp5,0);
    
    if(sgn<0)
    {
        
        // calc G_4
        for(j=0;j<k;j++)
        {
            mpz_pow_ui(tmp3,tmp1,n-sgnv[j]);
            mpz_mul(tmp3,tmp3,tmp2);
            
            if(mpz_cmp(tmp3,poly[sgnv[j]])<0)
            {
                mpz_cdiv_q(tmp1,poly[sgnv[j]],tmp2);
                mpz_rootrem(tmp1,tmp3,tmp1,n-sgnv[j]);
                if(mpz_sgn(tmp3)!=0)
                {
                    mpz_add_ui(tmp1,tmp1,1);
                }
            }
        }
        
        // calc G_2
        for(j=0;j<k;j++)
        {
            mpz_pow_ui(tmp3,tmp5,n-sgnv[j]);
            mpz_mul(tmp3,tmp3,tmp2);
            mpz_mul_ui(tmp4,poly[sgnv[j]],k);
            
            if(mpz_cmp(tmp3,tmp4)<0)
            {
                mpz_cdiv_q(tmp5,tmp4,tmp2);
                mpz_rootrem(tmp5,tmp3,tmp5,n-sgnv[j]);
                if(mpz_sgn(tmp3)!=0)
                {
                    mpz_add_ui(tmp5,tmp5,1);
                }
            }
        }
        
    }
    else
    {
        
        // calc G_4
        for(j=0;j<k;j++)
        {
            mpz_pow_ui(tmp3,tmp1,n-sgnv[j]);
            mpz_mul(tmp3,tmp3,tmp2);
            
            if(mpz_cmp(tmp3,poly[sgnv[j]])>0)
            {
                mpz_cdiv_q(tmp1,poly[sgnv[j]],tmp2);
                mpz_rootrem(tmp1,tmp3,tmp1,n-sgnv[j]);
                if(mpz_sgn(tmp3)!=0)
                {
                    mpz_add_ui(tmp1,tmp1,1);
                }
            }
        }
        
        // calc G_2
        for(j=0;j<k;j++)
        {
            mpz_pow_ui(tmp3,tmp5,n-sgnv[j]);
            mpz_mul(tmp3,tmp3,tmp2);
            mpz_mul_ui(tmp4,poly[sgnv[j]],k);
            
            if(mpz_cmp(tmp3,tmp4)>0)
            {
                mpz_cdiv_q(tmp5,tmp4,tmp2);
                mpz_rootrem(tmp5,tmp3,tmp5,n-sgnv[j]);
                if(mpz_sgn(tmp3)!=0)
                {
                    mpz_add_ui(tmp5,tmp5,1);
                }
            }
        }
        
    }
    
    // G_4's 2
    mpz_mul_ui(tmp1,tmp1,2);
    
    // max(G_4,G_2)
    if(mpz_cmp(tmp5, tmp1) < 0)
    {
        mpz_set(upperBound, tmp5);
    }else{
        mpz_set(upperBound, tmp1);
    }
    
    mm_mpz_release(tmp1);
    mm_mpz_release(tmp2);
    mm_mpz_release(tmp3);
    mm_mpz_release(tmp4);
    mm_mpz_release(tmp5);
}