#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <gmp.h>

mpz_t* generate(int n, mpz_t* solves)
{
    mpz_t *ret, *ret2, *swap;
    mpz_t temp, temp2;
    int i, j;
    
    ret = (mpz_t * )malloc(sizeof(mpz_t) * (n + 1));
    ret2 = (mpz_t * )malloc(sizeof(mpz_t) * (n + 1));
    
    mpz_init(temp);
    mpz_init(temp2);
    for(i = 0;i <= n;i++)
    {
        mpz_init(ret[i]);
        mpz_init(ret2[i]);
    }
    mpz_set_si(ret[1], 1);
    mpz_set(ret[0], solves[0]);
    
    for(i = 1;i < n;i++)
    {
        mpz_set_si(ret2[0], 0);
        for(j = 0;j < i + 1;j++)
        {
            mpz_set(ret2[j + 1], ret[j]);
        }
        
        for(j = 0;j < i + 1;j++)
        {
            mpz_mul(temp, ret[j], solves[i]);
            mpz_add(ret2[j], ret2[j], temp);
        }
        
        swap = ret;
        ret = ret2;
        ret2 = swap;
    }
    mpz_clear(temp);
    mpz_clear(temp2);
    for(i = 0;i < n + 1;i++)
    {
        mpz_clear(ret2[i]);
    }
    
    return ret;
}

int main(int argc, char* argv[])
{
    int i, n;
    mpz_t * solves;
    mpz_t * poly;
    FILE * file;
    
    if(argc != 3)
    {
        printf("Usage random_poly_gen.exe <dim> <out>\n");
        return 0;
    }
    
    file = fopen(argv[2], "w");
    
    n = atoi(argv[1]);
    
    solves = (mpz_t * )malloc(sizeof(mpz_t) * n);
    for(i = 0;i < n;i++)
    {
        mpz_init(solves[i]);
        mpz_set_si(solves[i], -(i + 1));
    }
    poly = generate(n, solves);
    for(i = n;i >= 0;i--)
    {
        fprintf(file, "(");
        mpz_out_str(file, 10, poly[i]);
        if(i == 0)
        {
            fprintf(file, ")");
        }else{
            fprintf(file, ")*x^%d+", i);
        }
    }
    
    fclose(file);

    return 0;
}
